// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from splsm_7:msg/SPLSM.idl
// generated code does not contain a copyright notice

#ifndef SPLSM_7__MSG__DETAIL__SPLSM__TRAITS_HPP_
#define SPLSM_7__MSG__DETAIL__SPLSM__TRAITS_HPP_

#include "splsm_7/msg/detail/splsm__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const splsm_7::msg::SPLSM & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: player_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "player_num: ";
    value_to_yaml(msg.player_num, out);
    out << "\n";
  }

  // member: team_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team_num: ";
    value_to_yaml(msg.team_num, out);
    out << "\n";
  }

  // member: fallen
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fallen: ";
    value_to_yaml(msg.fallen, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pose.size() == 0) {
      out << "pose: []\n";
    } else {
      out << "pose:\n";
      for (auto item : msg.pose) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ball_age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ball_age: ";
    value_to_yaml(msg.ball_age, out);
    out << "\n";
  }

  // member: ball
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ball.size() == 0) {
      out << "ball: []\n";
    } else {
      out << "ball:\n";
      for (auto item : msg.ball) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const splsm_7::msg::SPLSM & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<splsm_7::msg::SPLSM>()
{
  return "splsm_7::msg::SPLSM";
}

template<>
inline const char * name<splsm_7::msg::SPLSM>()
{
  return "splsm_7/msg/SPLSM";
}

template<>
struct has_fixed_size<splsm_7::msg::SPLSM>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<splsm_7::msg::SPLSM>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<splsm_7::msg::SPLSM>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SPLSM_7__MSG__DETAIL__SPLSM__TRAITS_HPP_
